diff --git a/globals.h b/globals.h
index 2fe3e72261..d0f632334a 100644
--- a/globals.h
+++ b/globals.h
@@ -25,6 +25,7 @@
 
 #include <signal.h>
 #include "lib/lib.h"
+#include "list.h"
 #include "where.h"
 #include "mutt_regex.h"
 
@@ -282,7 +283,7 @@ WHERE SIG_ATOMIC_VOLATILE_T SigWinch;
 WHERE int CurrentMenu;
 
 WHERE struct Alias *Aliases;
-WHERE struct List *UserHeader;
+WHERE struct STailQHead UserHeader INITVAL(STAILQ_HEAD_INITIALIZER(UserHeader));
 
 /* -- formerly in pgp.h -- */
 WHERE struct Regex PgpGoodSign;
diff --git a/init.c b/init.c
index cce4eb5822..0715a3551c 100644
--- a/init.c
+++ b/init.c
@@ -2035,43 +2035,29 @@ static int parse_alias(struct Buffer *buf, struct Buffer *s, unsigned long data,
 static int parse_unmy_hdr(struct Buffer *buf, struct Buffer *s,
                           unsigned long data, struct Buffer *err)
 {
-  struct List *last = NULL;
-  struct List *tmp = UserHeader;
-  struct List *ptr = NULL;
+  struct STailQNode *np, *tmp;
   size_t l;
 
   do
   {
     mutt_extract_token(buf, s, 0);
     if (mutt_strcmp("*", buf->data) == 0)
-      mutt_free_list(&UserHeader);
-    else
     {
-      tmp = UserHeader;
-      last = NULL;
+      mutt_free_stailq(&UserHeader);
+      continue;
+    }
 
-      l = mutt_strlen(buf->data);
-      if (buf->data[l - 1] == ':')
-        l--;
+    l = mutt_strlen(buf->data);
+    if (buf->data[l - 1] == ':')
+      l--;
 
-      while (tmp)
+    STAILQ_FOREACH_SAFE(np, &UserHeader, entries, tmp)
+    {
+      if ((mutt_strncasecmp(buf->data, np->data, l) == 0) && np->data[l] == ':')
       {
-        if ((mutt_strncasecmp(buf->data, tmp->data, l) == 0) && tmp->data[l] == ':')
-        {
-          ptr = tmp;
-          if (last)
-            last->next = tmp->next;
-          else
-            UserHeader = tmp->next;
-          tmp = tmp->next;
-          ptr->next = NULL;
-          mutt_free_list(&ptr);
-        }
-        else
-        {
-          last = tmp;
-          tmp = tmp->next;
-        }
+        STAILQ_REMOVE(&UserHeader, np, STailQNode, entries);
+        FREE(&np->data);
+        FREE(&np);
       }
     }
   } while (MoreArgs(s));
@@ -2081,7 +2067,7 @@ static int parse_unmy_hdr(struct Buffer *buf, struct Buffer *s,
 static int parse_my_hdr(struct Buffer *buf, struct Buffer *s,
                         unsigned long data, struct Buffer *err)
 {
-  struct List *tmp = NULL;
+  struct STailQNode *n = NULL;
   size_t keylen;
   char *p = NULL;
 
@@ -2093,32 +2079,30 @@ static int parse_my_hdr(struct Buffer *buf, struct Buffer *s,
   }
   keylen = p - buf->data + 1;
 
-  if (UserHeader)
+  STAILQ_FOREACH(n, &UserHeader, entries)
   {
-    for (tmp = UserHeader;; tmp = tmp->next)
+    /* see if there is already a field by this name */
+    if (mutt_strncasecmp(buf->data, n->data, keylen) == 0)
     {
-      /* see if there is already a field by this name */
-      if (mutt_strncasecmp(buf->data, tmp->data, keylen) == 0)
-      {
-        /* replace the old value */
-        FREE(&tmp->data);
-        tmp->data = buf->data;
-        mutt_buffer_init(buf);
-        return 0;
-      }
-      if (!tmp->next)
-        break;
+      break;
     }
-    tmp->next = mutt_new_list();
-    tmp = tmp->next;
+  }
+
+  if (!n)
+  {
+    /* not found, allocate memory for a new node and add it to the list */
+    n = safe_calloc(1, sizeof(struct STailQNode));
+    STAILQ_INSERT_TAIL(&UserHeader, n, entries);
   }
   else
   {
-    tmp = mutt_new_list();
-    UserHeader = tmp;
+    /* found, free the existing data */
+    FREE(&n->data);
   }
-  tmp->data = buf->data;
+
+  n->data = buf->data;
   mutt_buffer_init(buf);
+
   return 0;
 }
 
diff --git a/send.c b/send.c
index 0344b5ed37..2169611c7d 100644
--- a/send.c
+++ b/send.c
@@ -250,7 +250,6 @@ static int edit_address(struct Address **a, /* const */ char *field)
 static int edit_envelope(struct Envelope *en, int flags)
 {
   char buf[HUGE_STRING];
-  struct List *uh = UserHeader;
 
 #ifdef USE_NNTP
   if (option(OPT_NEWS_SEND))
@@ -309,7 +308,8 @@ static int edit_envelope(struct Envelope *en, int flags)
     const char *p = NULL;
 
     buf[0] = 0;
-    for (; uh; uh = uh->next)
+    struct STailQNode *uh;
+    STAILQ_FOREACH(uh, &UserHeader, entries)
     {
       if (mutt_strncasecmp("subject:", uh->data, 8) == 0)
       {
@@ -340,9 +340,8 @@ static char *nntp_get_header(const char *s)
 
 static void process_user_recips(struct Envelope *env)
 {
-  struct List *uh = UserHeader;
-
-  for (; uh; uh = uh->next)
+  struct STailQNode *uh;
+  STAILQ_FOREACH(uh, &UserHeader, entries)
   {
     if (mutt_strncasecmp("to:", uh->data, 3) == 0)
       env->to = rfc822_parse_adrlist(env->to, uh->data + 3);
@@ -363,9 +362,8 @@ static void process_user_recips(struct Envelope *env)
 
 static void process_user_header(struct Envelope *env)
 {
-  struct List *uh = UserHeader;
-
-  for (; uh; uh = uh->next)
+  struct STailQNode *uh;
+  STAILQ_FOREACH(uh, &UserHeader, entries)
   {
     if (mutt_strncasecmp("from:", uh->data, 5) == 0)
     {
